searchData={"items":[{"type":"module","title":"Mississippi","doc":"Documentation for `Mississippi`.","ref":"Mississippi.html"},{"type":"behaviour","title":"Mississippi.AMQPConnection","doc":"A behaviour module to for implementing a DataConsumer AMQP connection.","ref":"Mississippi.AMQPConnection.html"},{"type":"callback","title":"Mississippi.AMQPConnection.adapter/0","doc":"The adapter module for the AMQP connection","ref":"Mississippi.AMQPConnection.html#c:adapter/0"},{"type":"callback","title":"Mississippi.AMQPConnection.init/1","doc":"Initializes the AMQP connection.\nReturns `{:ok, channel}` if it was initialized successfully, or `{:error, reason}` if it was not.","ref":"Mississippi.AMQPConnection.html#c:init/1"},{"type":"module","title":"Mississippi.Consumer","doc":"This module defines the supervision tree of Mississippi.Consumer.","ref":"Mississippi.Consumer.html"},{"type":"function","title":"Mississippi.Consumer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Mississippi.Consumer.html#child_spec/1"},{"type":"type","title":"Mississippi.Consumer.init_options/0","doc":"","ref":"Mississippi.Consumer.html#t:init_options/0"},{"type":"function","title":"Mississippi.Consumer.start_link/1","doc":"","ref":"Mississippi.Consumer.html#start_link/1"},{"type":"module","title":"Mississippi.Consumer.AMQPDataConsumer","doc":"The AMQPDataConsumer process fetches messages from a Mississippi AMQP queue and\nsends them to MessageTrackers according to the message sharding key.","ref":"Mississippi.Consumer.AMQPDataConsumer.html"},{"type":"function","title":"Mississippi.Consumer.AMQPDataConsumer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Mississippi.Consumer.AMQPDataConsumer.html#child_spec/1"},{"type":"function","title":"Mississippi.Consumer.AMQPDataConsumer.start_link/1","doc":"","ref":"Mississippi.Consumer.AMQPDataConsumer.html#start_link/1"},{"type":"behaviour","title":"Mississippi.Consumer.DataUpdater","doc":"The DataUpdater process takes care of handling messages and signals for a given sharding key.\nMessages are handled using the `message_handler` providedin the Mississippi config,\nwhich is a module implementing DataUpdater.Handler behaviour.\nNote that the DataUpdater process has no concept of message ordering, as it is the\nMessageTracker process that takes care of maitaining the order of messages.","ref":"Mississippi.Consumer.DataUpdater.html"},{"type":"function","title":"Mississippi.Consumer.DataUpdater.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Mississippi.Consumer.DataUpdater.html#child_spec/1"},{"type":"function","title":"Mississippi.Consumer.DataUpdater.get_data_updater_process/1","doc":"Provides a reference to the DataUpdater process that will handle the set of messages identified by\nthe given sharding key.","ref":"Mississippi.Consumer.DataUpdater.html#get_data_updater_process/1"},{"type":"callback","title":"Mississippi.Consumer.DataUpdater.get_data_updater_process/1","doc":"","ref":"Mississippi.Consumer.DataUpdater.html#c:get_data_updater_process/1"},{"type":"function","title":"Mississippi.Consumer.DataUpdater.handle_message/2","doc":"Handle a message using the `message_handler` provided in the Mississippi config\n(which is a module implementing DataUpdater.Handler behaviour).\nYou can get the DataUpdater instance for a given sharding_key using `get_data_updater_process/1`.","ref":"Mississippi.Consumer.DataUpdater.html#handle_message/2"},{"type":"function","title":"Mississippi.Consumer.DataUpdater.handle_signal/2","doc":"Handles an information that must be forwarded to a `message_handler` but is not a Mississippi message.\nUsed to change the state of a stateful Handler. The call is blocking and there is no ordering guarantee.\nYou can get the DataUpdater instance for a given sharding_key using `get_data_updater_process/1`.","ref":"Mississippi.Consumer.DataUpdater.html#handle_signal/2"},{"type":"function","title":"Mississippi.Consumer.DataUpdater.start_link/2","doc":"","ref":"Mississippi.Consumer.DataUpdater.html#start_link/2"},{"type":"behaviour","title":"Mississippi.Consumer.DataUpdater.Handler","doc":"A behaviour module to for implementing a Processor of Mississippi messages.\nMessages sharing the same sharding key are processed in order.","ref":"Mississippi.Consumer.DataUpdater.Handler.html"},{"type":"callback","title":"Mississippi.Consumer.DataUpdater.Handler.handle_continue/2","doc":"Invoked when `handle_message/5` returns a `{:continue, continue_arg}` tuple.\nUsed to update the state of a stateful handler.","ref":"Mississippi.Consumer.DataUpdater.Handler.html#c:handle_continue/2"},{"type":"callback","title":"Mississippi.Consumer.DataUpdater.Handler.handle_message/5","doc":"Invoked when a message is received. Possible return values are:\n* `{:ack, result, state}`: Mississippi acks the message\n* `{:ack, result, state, {:continue, continue_arg}}`: Mississippi acks the message and\n  the DataUpdater process continues as specified by the `handle_continue/2` callback\n* `{:discard, reason, state}`: Mississippi discards the message\n* `{:discard, result, state, {:continue, continue_arg}}`: Mississippi discards the message and\n  the DataUpdater process continues as specified by the `handle_continue/2` callback\n* `{:stop, reason, action, state}`: Mississippi acks or discards the message according to `action`\n  and then the DataUpdater process terminates normally.\n  This makes the related MessageTracker terminate, too.","ref":"Mississippi.Consumer.DataUpdater.Handler.html#c:handle_message/5"},{"type":"callback","title":"Mississippi.Consumer.DataUpdater.Handler.handle_signal/2","doc":"Invoked when an information that is not a message is received.\nUsed to update the state of a stateful handler.\nThere is no guarantee of ordering.","ref":"Mississippi.Consumer.DataUpdater.Handler.html#c:handle_signal/2"},{"type":"type","title":"Mississippi.Consumer.DataUpdater.Handler.handler_state/0","doc":"","ref":"Mississippi.Consumer.DataUpdater.Handler.html#t:handler_state/0"},{"type":"callback","title":"Mississippi.Consumer.DataUpdater.Handler.init/1","doc":"Invoked when the handler is initialized. This can be used to make the handler stateful.\nThe sharding key for this Handler  is passed as an argument to the callback.\nAn `{:error, reason}` return value will make handler initialization fail. In that case, the\nhandler will be restarted and messages which have been prefetched will be requed in the original order.","ref":"Mississippi.Consumer.DataUpdater.Handler.html#c:init/1"},{"type":"callback","title":"Mississippi.Consumer.DataUpdater.Handler.terminate/2","doc":"Invoked when the handler is being terminated. It can be used to perform cleanup tasks before closing.","ref":"Mississippi.Consumer.DataUpdater.Handler.html#c:terminate/2"},{"type":"behaviour","title":"Mississippi.Consumer.MessageTracker","doc":"The MessageTracker process guarantees that messages sharing the same sharding key\nare processed in (chronological) order.\nUnder the hood, messages are put in a FIFO queue, and the next message is processed\nonly if the current one has been handled (either acked or rejected).\nIn order to maintain the strong ordering guarantee, it is possible that in some corner cases\na message gets processed twice, but after all with strange aeons, even death may die.","ref":"Mississippi.Consumer.MessageTracker.html"},{"type":"function","title":"Mississippi.Consumer.MessageTracker.ack_delivery/2","doc":"Signals to the MessageTracker process to ack the message.\nThis call is blocking, as only first in-order message can be acked.","ref":"Mississippi.Consumer.MessageTracker.html#ack_delivery/2"},{"type":"function","title":"Mississippi.Consumer.MessageTracker.get_message_tracker/1","doc":"Provides a reference to the MessageTracker process that will track the set of messages identified by\nthe given sharding key.","ref":"Mississippi.Consumer.MessageTracker.html#get_message_tracker/1"},{"type":"callback","title":"Mississippi.Consumer.MessageTracker.get_message_tracker/1","doc":"","ref":"Mississippi.Consumer.MessageTracker.html#c:get_message_tracker/1"},{"type":"function","title":"Mississippi.Consumer.MessageTracker.handle_message/3","doc":"Starts handling a message. This call is not blocking.\nThe message will be put in the MessageTracker process FIFO queue, and processed\nwhen it is on top of it.","ref":"Mississippi.Consumer.MessageTracker.html#handle_message/3"},{"type":"function","title":"Mississippi.Consumer.MessageTracker.reject/2","doc":"Signals to the MessageTracker process to reject the message.\nThis call is blocking, as only first in-order message can be rejected.","ref":"Mississippi.Consumer.MessageTracker.html#reject/2"},{"type":"module","title":"Mississippi.Consumer.MessageTracker.Server","doc":"This module implements the MessageTracker process logic.","ref":"Mississippi.Consumer.MessageTracker.Server.html"},{"type":"function","title":"Mississippi.Consumer.MessageTracker.Server.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Mississippi.Consumer.MessageTracker.Server.html#child_spec/1"},{"type":"function","title":"Mississippi.Consumer.MessageTracker.Server.start_link/1","doc":"","ref":"Mississippi.Consumer.MessageTracker.Server.html#start_link/1"},{"type":"module","title":"Mississippi.Producer","doc":"This module defines the supervision tree of Mississippi.Producer.","ref":"Mississippi.Producer.html"},{"type":"function","title":"Mississippi.Producer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Mississippi.Producer.html#child_spec/1"},{"type":"type","title":"Mississippi.Producer.init_options/0","doc":"","ref":"Mississippi.Producer.html#t:init_options/0"},{"type":"function","title":"Mississippi.Producer.start_link/1","doc":"","ref":"Mississippi.Producer.html#start_link/1"},{"type":"module","title":"Mississippi.Producer.EventsProducer","doc":"The entry point for publishing messages on Mississippi.","ref":"Mississippi.Producer.EventsProducer.html"},{"type":"function","title":"Mississippi.Producer.EventsProducer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Mississippi.Producer.EventsProducer.html#child_spec/1"},{"type":"function","title":"Mississippi.Producer.EventsProducer.publish/2","doc":"Publish a message on Mississippi AMQP queues. The call is blocking, as only one message at a time can be published.","ref":"Mississippi.Producer.EventsProducer.html#publish/2"},{"type":"type","title":"Mississippi.Producer.EventsProducer.publish_opts/0","doc":"","ref":"Mississippi.Producer.EventsProducer.html#t:publish_opts/0"},{"type":"function","title":"Mississippi.Producer.EventsProducer.start_link/1","doc":"","ref":"Mississippi.Producer.EventsProducer.html#start_link/1"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.0"}}